;WinAsm Studio Add-Ins Header (WAAddInFasm.inc)
;Converted by Shoorick from original WAAddIn.inc
;Updated for up to V5.1.0.xx
;Updated for fasm 1.62+
;-----------------------------------------------------------------------

;Use it to get a menu ID for your addin
WAM_GETNEXTMENUID           EQU WM_USER+100 ;hWnd   = hMain
                                            ;wParam = 0
                                            ;lParam = 0

;Fills the CURRENTPROJECTINFO structure: only if there's an open project (3.0.0.0 to 3.0.1.3)
;                                                                                always (3.0.1.4+)
;Returns 0 if there is no open project, nonzero otherwise
WAM_GETCURRENTPROJECTINFO   EQU WM_USER+101 ;hWnd   = hMain
                                            ;wParam = LPCURRENTPROJECTINFO
                                            ;lParam = 0
struct CURRENTPROJECTINFO
	pszFullProjectName        dd ?
	pbModified                dd ? ;pointer to modified flag (TRUE/FALSE)
	pszCompileRCCommand       dd ?
	pszResToObjCommand        dd ?
	pszReleaseAssembleCommand dd ?
	pszReleaseLinkCommand     dd ?
	pszReleaseOUTCommand      dd ?
	pProjectType              dd ? ;pointer to project type (0-6)
	pszDebugAssembleCommand   dd ? ;(3.0.1.4+)
	pszDebugLinkCommand       dd ? ;(3.0.1.4+)
	pszDebugOUTCommand        dd ? ;(3.0.1.4+)
	pszProjectTitle           dd ? ;(3.0.1.4+)

	pszReleaseCommandLine     dd ? ;(3.0.2.7+)     ;optional command line to be passed by WinAsm Studio when runs executable project and active build is Release Version
	pszDebugCommandLine       dd ? ;(3.0.2.7+)     ;optional command line to be passed by WinAsm Studio when runs executable project and active build is Debug Version
ends

;Enumerate all files of current project
WAM_ENUMCURRENTPROJECTFILES	EQU WM_USER+102 ;hWnd   = hMain
                                            ;wParam = pointer to EnumProc
                                            ;lParam = 0

;Adds an existing file to the project, or opens an external file
;lParam: TRUE to Add File to the current project, FALSE to Open File external to the current project
WAM_ADDOPENEXISTINGFILE     EQU WM_USER+103 ;hWnd   = hMain
                                            ;wParam = lpFileName
                                            ;lParam = TRUE/FALSE

;Opens an entire project
WAM_OPENPROJECT             EQU WM_USER+104 ;hWnd   = hMain
                                            ;wParam = lpProjectFileName
                                            ;lParam = reserved

;Enumerate all external files
WAM_ENUMEXTERNALFILES       EQU WM_USER+105 ;hWnd   = hMain
                                            ;wParam = pointer to EnumProc
                                            ;lParam = 0

WAM_ENABLEALLDOCKWINDOWS    EQU WM_USER+106 ;hWnd   = hMain
                                            ;wParam = 0
                                            ;lParam = TRUE/FALSE

WAM_DIFFERENTCURRENTPROJECT EQU WM_USER+107 ;hWnd   = hMain

;After every WM_COMMAND WinAsm Studio processes, sends WAE_COMMANDFINISHED
;back to all Add-Ins in the FrameWindowProc Procedure therefore wParam
;and lParam are equal to those of the WM_COMMAND message WinAsm Studio
;just processed.
WAE_COMMANDFINISHED     EQU WM_USER+200 ;hWnd   = hMain (FrameWindowProc)
                                        ;wParam = (?)
                                        ;lParam = (?)

;******************************************************************************
;Docking Windows
struct POSANDSIZE
       dLeft    dd ?
       dTop     dd ?
       dWidth   dd ?
       dHeight  dd ?
ends

;Title Styles
STYLE_GRADIENTTITLE	       EQU 000h
STYLE_TWOLINESTITLE	       EQU 001h
STYLE_ONELINETITLE	       EQU 002h

;Constants for fDockedTo
NODOCK			       EQU 0
LEFTDOCK		       EQU 1
RIGHTDOCK		       EQU 2
TOPDOCK 		       EQU 3
BOTTOMDOCK		       EQU 4

struct DOCKINGDATA
    lpCaption           dd ?
    fDockedTo           dd ?    ;Use one of the following: NODOCK,LEFTDOCK,RIGHTDOCK,TOPDOCK,BOTTOMDOCK
    NoDock              POSANDSIZE
    DockTopHeight       dd ?
    DockBottomHeight    dd ?
    DockLeftWidth       dd ?
    DockRightWidth      dd ?

    ;Do not touch these!
    reserved1           dd ?
    reserved2           dd ?
    reserved3           RECT
    reserved4           POINT
ends

;
;For docking windows use ONLY this messages, NOT their API counterparts
WAM_CREATEDOCKINGWINDOW     EQU WM_USER+151 ;hWnd   = hMain
                                            ;wParam = Window Style, recommend (WS_VISIBLE OR WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_CHILD or STYLE_xxx) --->WS_CHILD is a must!
                                            ;lParam = lpDockData (LPDOCKINGDATA)

WAM_GETCLIENTRECT           EQU WM_USER+152 ;hWnd   = hAddInWindow
                                            ;wParam = 0
                                            ;lParam = lpRect (LPRECT)

WAM_DESTROYDOCKINGWINDOW    EQU WM_USER+153 ;hWnd   = hAddInWindow
                                            ;wParam = 0
                                            ;lParam = 0


;End Of Docking windows
;******************************************************************************
;
;WinAsm Studio handles structures, get this at WAAddInLoad

struct POPUPMENUS
       hFileMenu           dd   ?
       hEditMenu           dd   ?
       hViewMenu           dd   ?
       hProjectMenu        dd   ?
       hFormatMenu         dd   ?
       hResourcesMenu      dd   ?
       hMakeMenu           dd   ?
       hSetActiveBuildMenu dd   ?
       hToolsMenu          dd   ?
       hAddInsMenu         dd   ?
       hWindowMenu         dd   ?
       hHelpMenu           dd   ?
       hNewFileMenu        dd   ?		    ;in "File"
       hConvertMenu        dd   ?		    ;in "Format"
       hControlsMenu       dd   ?		    ;Rightclick on toolbox
       hDialogMenu         dd   ?		    ;In Resources
       hInterfacePacks     dd   ?		    ;In Tools
ends

struct HANDLES
       hMain                dd ?
       hMenu                dd ?
       hClient              dd ?
       hStatus              dd ?
       hRebar               dd ?
       hMainTB              dd ?
       hEditTB              dd ?
       hMakeTB              dd ?
       Reserved1            dd ?
       Reserved2            dd ?
       hProjExplorer        dd ?
       hProjTab             dd ?
       hProjTree            dd ?
       hBlocksList          dd ?
       hOutParent           dd ?
       hOut                 dd ?
       phImlNormal          dd ?
       phImlMonoChrome      dd ?
       phAcceleratorTable   dd ? ;Pointer to the Accelerator Table handle
       PopUpMenus			POPUPMENUS
ends

struct WA_DEFINE
    szName            rb 64+1
    dwValue           dd ?
    ;fDeleted         dd ?
    ReferenceCount    dd ?
ends

;WinAsm Studio features structures, get this at WAAddInLoad
struct FEATURES
       Version                             dd ?	     ;Decimal number, version 3.0.1.4 is 3014
       ppAddInsFrameProcedures             dd ?	     ;Pointer to pointer to AddInsFrameProcedures list
       ppAddInsChildWindowProcedures       dd ?	     ;Pointer to pointer to AddInsChildWindowProcedures list
       ppAddInsProjectExplorerProcedures   dd ?	     ;Pointer to pointer to AddInsProjectExplorerProcedures list
       ppAddInsOutWindowProcedures         dd ?	     ;Pointer to pointer to AddInsOutWindowProcedures list

       phRCEditorWindow                    dd ?		;pointer to hRCEditor MDI Child window; e.g. MOV EAX,phRCEditorWindow-->MOV EDX,[EAX]-->EDX is window handle or 0 if resource file is NOT in Visual mode
       plpDefinesMem                       dd ?		;Pointer to pointer to resource define statements memory ; e.g. MOV EAX,plpDefinesMem-->MOV EDX,[EAX]-->EDX is pointer to define statements memory-->Use [EDX].DEFINE.xxxx
ends

;Comment $
;Example Usage: FASM EXAMPLES
;--------------
;
;In the WAAddInLoad Procedure
;----------------------------
;       mov  ebx,[pWinAsmHandles]
;       push [ebx + HANDLES.hClient]
;       pop  [hClient]
;
;Any procedure
;----------------------------------------------
;       invoke SendMessage,[hClient],WM_MDIGETACTIVE,0,0
;       test eax,eax
;       jz @F
;       invoke GetWindowLong,eax,0
;       ;Now [eax + CHILDDATA.TypeOfFile]=1 or 2 or ...7
;       .
;       .
;       .
;  @@:
;$

;--------------------------
	MAX_PATH	equ 260
;--------------------------

;if ~ defined CHARRANGE | defined chrg_in_waaddininc
;    chrg_in_waaddininc = 1
;    struct CHARRANGE
;        cpMin dd ?
;        cpMax dd ?
;    ends
;end if

struct CHSELCHANGE
       nmhdr        NMHDR
       chrg         CHARRANGE 
       seltyp       dw ?		;SEL_TEXT or SEL_OBJECT
       linenr       dd ?		;Line number
       cpLine       dd ?		;Character position of first character
       lpLine       dd ?		;Pointer to line
       nlines       dd ?		;Total number of lines
       nhidden      dd ?		;Total number of hidden lines
       fchanged     dd ?		;TRUE if changed since last
       npage        dd ?		;Page number
       nWordGroup   dd ?		;Hilite word group
ends

struct RAFONT
	hFont		dd ?						;Code edit normal
	hIFont		dd ?						;Code edit italics
	hLnrFont	dd ?						;Line numbers
ends

struct CHILDDATA
        hEditor     dd ?
        hCombo      dd ?
        hTreeItem   dd ?
        TypeOfFile  dd ?        ;1=asm, 2=inc, 3=rc, 4=txt, 5=def, 6=bat, 7=other
                                ;Similarly 101=external *.asm, 102=external *.inc etc
                                ;51=module
        FileName    rb MAX_PATH ;
ends

;Example Usage:
;---------------
;;e.g.1 invoke SendMessage,[hMain],WM_COMMAND,0 (or 1 it doesn't matter),IDM_ ....
;
;;e.g.2 Probably In the FrameWindowProc:
;
;           cmp [uMsg],WM_COMMAND
;           jne @F
;           mov eax,[wParam]
;           and eax, not 10000h     ; clear bit 10000h
;                                   ; it is 0 for menu, and 1 for accelerator. Toolbar messages act like menu messages...
;           cmp eax,IDM_OPENPROJECT ; for example
;           jne @F
;           ;Do something here
;           ;
;           ;
;
;           mov eax,TRUE    ;If you do not want WinAsm Studio or Other Add-Ins to process this message.
;               OR
;           xor eax,eax     ;If you want WinAsm Studio AND Other Add-Ins to process this message.
;
;           retn
;      @@:
;---------------------------------------------------------------------------
;Menu/Toolbar command identifiers
IDM_FILE                            EQU 9001
IDM_EDIT                            EQU 9002
IDM_VIEW                            EQU 9003
IDM_PROJECT                         EQU 9004
IDM_FORMAT                          EQU 9005
IDM_RESOURCES                       EQU 9006
IDM_MAKE                            EQU 9007
IDM_TOOLS                           EQU 9008
IDM_ADDINS                          EQU 9009
IDM_WINDOW                          EQU 9010
IDM_HELP                            EQU 9011

IDM_NEWPROJECT                      EQU 10001
IDM_OPENPROJECT                     EQU 10002
IDM_CLOSEPROJECT                    EQU 10006
IDM_SAVEPROJECT                     EQU 10003
IDM_SAVEPROJECTAS                   EQU 10004
IDM_OPENFILES                       EQU 10005

IDM_SAVEFILE                        EQU 10007
IDM_SAVEFILEAS                      EQU 10008
IDM_PRINT                           EQU 10009
IDM_RECENTPROJECTSMANAGER           EQU 10010
IDM_EXIT                            EQU 10011
IDM_RESTORE                         EQU 10012

IDM_NEWASMFILE                      EQU 10013
IDM_NEWINCFILE                      EQU 10014
IDM_NEWRCFILE                       EQU 10015
IDM_NEWOTHERFILE                    EQU 10016

IDM_EDIT_UNDO                       EQU 10101
IDM_EDIT_REDO                       EQU 10102
IDM_EDIT_CUT                        EQU 10103
IDM_EDIT_COPY                       EQU 10104
IDM_EDIT_PASTE                      EQU 10105
IDM_EDIT_DELETE                     EQU 10106
IDM_EDIT_SELECTALL                  EQU 10107
IDM_EDIT_FIND                       EQU 10108
IDM_EDIT_FINDNEXT                   EQU 10109
IDM_EDIT_REPLACE                    EQU 10110
IDM_EDIT_GOTOLINE                   EQU 10111
IDM_EDIT_GOTOBLOCK                  EQU 10112
IDM_EDIT_GOBACK                     EQU 10113
IDM_EDIT_TOGGLEBM                   EQU 10114
IDM_EDIT_NEXTBM                     EQU 10115
IDM_EDIT_PREVBM                     EQU 10116
IDM_EDIT_CLEARBM                    EQU 10117
IDM_EDIT_SMARTFIND                  EQU 10118
IDM_EDIT_FINDPREVIOUS               EQU 10119
IDM_EDIT_HIDELINES                  EQU 10120

IDM_VIEW_PROJECTEXPLORER            EQU 10201
IDM_VIEW_OUTPUT                     EQU 10202

IDM_PROJECT_ADDASM                  EQU 10301
IDM_PROJECT_ADDINC                  EQU 10302
IDM_PROJECT_ADDRC                   EQU 10303
IDM_PROJECT_ADDOTHER                EQU 10304
IDM_PROJECT_ADDEXISTINGFILE         EQU 10305
IDM_PROJECT_REMOVEFILE              EQU 10306
IDM_PROJECT_PROPERTIES              EQU 10307
IDM_PROJECT_RUNBATCH                EQU 10308
IDM_PROJECT_RENAMEFILE              EQU 10309
;IDM_PROJECT_USEEXTRCEDITOR          EQU 10310
;IDM_PROJECT_VISUALMODE              EQU 10311
IDM_PROJECT_SETASMODULE             EQU 10312
IDM_PROJECT_TESTDIALOG              EQU 10313
IDM_PROJECT_BINARYFILES             EQU 10314
IDM_PROJECT_RENAMEPROJECT           EQU 10315

IDM_FORMAT_INDENT                   EQU 10401
IDM_FORMAT_OUTDENT                  EQU 10402
IDM_FORMAT_COMMENT                  EQU 10403
IDM_FORMAT_UNCOMMENT                EQU 10404
IDM_CONVERTTOUPPERCASE              EQU 10405
IDM_CONVERTTOLOWERCASE              EQU 10406
IDM_TOGGLECASE                      EQU 10407

IDM_MAKE_COMPILERESOURCE            EQU 10501
IDM_MAKE_RCTOOBJ                    EQU 10502
IDM_MAKE_ASSEMBLE                   EQU 10503
IDM_MAKE_LINK                       EQU 10504
IDM_MAKE_GO                         EQU 10505
IDM_MAKE_EXECUTE                    EQU 10506
IDM_MAKE_DEBUG                      EQU 10507
IDM_MAKEACTIVERELEASEVERSION        EQU 10508
IDM_MAKEACTIVEDEBUGVERSION          EQU 10509
IDM_MAKE_CLEAN                      EQU 10510
IDM_MAKE_STOP                       EQU 10511

IDM_WINDOW_CLOSE                    EQU 10701
IDM_WINDOW_NEXT                     EQU 10702
IDM_WINDOW_PREVIOUS                 EQU 10703
IDM_WINDOW_TILEHORIZONTALLY         EQU 10704
IDM_WINDOW_TILEVERTICALLY           EQU 10705
IDM_WINDOW_CASCADE                  EQU 10706
IDM_WINDOW_CLOSEALL                 EQU 10707

IDM_HELP_ABOUT                      EQU 10801
IDM_HELP_HELPCONTENTS               EQU 10802
IDM_HELP_HELPKEY                    EQU 10803
IDM_HELPONTHEWEB                    EQU 10805
IDM_HELP_WINASMHELP                 EQU 10804


IDM_TOOLS_CODEEDITORFONT            EQU 10901
IDM_TOOLS_LINENUMBERFONT            EQU 10902
IDM_TOOLS_OPTIONS                   EQU 10903
IDM_TOOLS_TOOLSMANAGER              EQU 10904
;IDM_TOOLS_RESERVED                 EQU 10905

IDM_COPYSELECTION                   EQU 11001
IDM_COPYALLTEXT                     EQU 11002
IDM_SAVEOUTTEXT                     EQU 11003

;----------------------------------------
IDM_RESOURCES_VISUALMODE            EQU 11202
IDM_RESOURCES_USEEXTRCEDITOR        EQU 11203
IDM_RESOURCES_DEFINITIONSMANAGER    EQU 11204	

IDM_DIALOG_SHOWHIDEGRID             EQU 11301
IDM_DIALOG_SNAPTOGRID               EQU 11302

IDM_DIALOG_CUT                      EQU 11304
IDM_DIALOG_COPY                     EQU 11305
IDM_DIALOG_PASTE                    EQU 11306
IDM_DIALOG_DELETE                   EQU 11307


IDM_DIALOG_STYLE                    EQU 11319
IDM_DIALOG_EXSTYLE                  EQU 11320
IDM_DIALOG_DIALOGFONT               EQU 11321

IDM_DIALOG_SENDTOBACK               EQU 11325
IDM_DIALOG_BRINGONTOP               EQU 11326
IDM_DIALOG_RESERVED                 EQU 11327
IDM_DIALOG_TESTDIALOG               EQU 11328
IDM_DIALOG_UNDO                     EQU 11329
IDM_DIALOG_REDO                     EQU 11330
IDM_DIALOG_CONTROLSMANAGER          EQU 11331
;-----------------------------------------

IDM_ADDINS_ADDINSMANAGER            EQU 12001

IDM_STYLE_GRADIENTTITLE             EQU 13001
IDM_STYLE_TWOLINESTITLE             EQU 13002
IDM_STYLE_ONELINETITLE              EQU 13003

struct ADDINMENUITEM
       hBitmapNormal       dd ?
       hBitmapDisabled     dd ?
       lpCaption           dd ?
ends

;NOTE1: 10021 (including) UP TO 10026 (including) are the 6 recent projects (all below File-Print).
;NOTE2: 30001 (including) UP TO 30020 (including) are the External tools commands (all below Tools-Tools Manager).
;NOTE3: 40001 (including) UP TO 50000 (including) are the Add-Ins menu items.
;NOTE4: 50001 (including) Upwards are the Opened External Files (in Window menu after Cascade)
;NOTE5: 30101 (including) upwards are the User Interface DLL's
;---------------------------------------------------------------------------


;--------------------------------------------------------------------------------
;CodeHi user messages
CHM_BASE                    EQU WM_USER +1000
CHM_SETHILITEWORDS          EQU CHM_BASE+0	       ;wParam=Color                   lParam=lpszWords
CHM_SETFONT                 EQU CHM_BASE+1	       ;wParam=0                               lParam=lpRAFONT
CHM_GETFONT                 EQU CHM_BASE+2	       ;wParam=0                               lParam=lpRAFONT
CHM_SETCOLOR                EQU CHM_BASE+3	       ;wParam=0                               lParam=lpRACOLOR
CHM_GETCOLOR                EQU CHM_BASE+4	       ;wParam=0                               lParam=lpRACOLOR
CHM_SETHILITELINE           EQU CHM_BASE+5	       ;wParam=Line                    lParam=Color
CHM_GETHILITELINE           EQU CHM_BASE+6	       ;wParam=Line                    lParam=0
CHM_SETBOOKMARK             EQU CHM_BASE+7	       ;wParam=Line                    lParam=Type
CHM_GETBOOKMARK             EQU CHM_BASE+8	       ;wParam=Line                    lParam=0
CHM_CLRBOOKMARKS            EQU CHM_BASE+9	       ;wParam=0                               lParam=Type
CHM_NXTBOOKMARK             EQU CHM_BASE+10	       ;wParam=Line                    lParam=Type
CHM_PRVBOOKMARK             EQU CHM_BASE+11	       ;wParam=Line                    lParam=Type
CHM_FINDBOOKMARK            EQU CHM_BASE+12	       ;wParam=BmID                    lParam=0
CHM_SETBLOCKS               EQU CHM_BASE+13	       ;wParam=[lpLINERANGE]   lParam=lpRABLOCKDEF
CHM_ISLINE                  EQU CHM_BASE+14	       ;wParam=Line                    lParam=lpszDef
CHM_GETWORD                 EQU CHM_BASE+15	       ;wParam=BuffSize                lParam=lpBuff
CHM_COLLAPSE                EQU CHM_BASE+16	       ;wParam=Line                    lParam=lpRABLOCKDEF
CHM_COLLAPSEALL             EQU CHM_BASE+17	       ;wParam=0                               lParam=lpRABLOCKDEF
CHM_EXPAND                  EQU CHM_BASE+18	       ;wParam=Line                    lParam=lpRABLOCKDEF
CHM_EXPANDALL               EQU CHM_BASE+19	       ;wParam=0                               lParam=lpRABLOCKDEF
CHM_LOCKLINE                EQU CHM_BASE+20	       ;wParam=Line                    lParam=TRUE/FALSE
CHM_ISLINELOCKED            EQU CHM_BASE+21	       ;wParam=Line                    lParam=0
CHM_HIDELINE                EQU CHM_BASE+22	       ;wParam=Line                    lParam=TRUE/FALSE
CHM_ISLINEHIDDEN            EQU CHM_BASE+23	       ;wParam=Line                    lParam=0
CHM_AUTOINDENT              EQU CHM_BASE+24	       ;wParam=0                               lParam=TRUE/FALSE
CHM_TABWIDTH                EQU CHM_BASE+25	       ;wParam=nChars                  lParam=TRUE/FALSE (Expand tabs)
CHM_SELBARWIDTH             EQU CHM_BASE+26	       ;wParam=nWidth                  lParam=0
CHM_LINENUMBERWIDTH         EQU CHM_BASE+27	       ;wParam=nWidth                  lParam=0
CHM_MOUSEWHEEL              EQU CHM_BASE+28	       ;wParam=nLines                  lParam=0
CHM_SUBCLASS                EQU CHM_BASE+29	       ;wParam=0                               lParam=lpWndProc
CHM_SETSPLIT                EQU CHM_BASE+30	       ;wParam=nSplit                  lParam=0
CHM_GETSPLIT                EQU CHM_BASE+31	       ;wParam=0                               lParam=0
CHM_VCENTER                 EQU CHM_BASE+32	       ;wParam=0                               lParam=0
CHM_REPAINT                 EQU CHM_BASE+33	       ;wParam=0                               lParam=TRUE/FALSE (Paint Now)
CHM_BMCALLBACK              EQU CHM_BASE+34	       ;wParam=0                               lParam=lpBmProc
CHM_READONLY                EQU CHM_BASE+35	       ;wParam=0                               lParam=TRUE/FALSE
CHM_INVALIDATELINE          EQU CHM_BASE+36	       ;wParam=Line                    lParam=0
CHM_SETPAGESIZE             EQU CHM_BASE+37	       ;wParam=nLines                  lParam=0
CHM_GETPAGESIZE             EQU CHM_BASE+38	       ;wParam=0                               lParam=0
CHM_GETCHARTAB              EQU CHM_BASE+39	       ;wParam=nChar                   lParam=0
CHM_SETCHARTAB              EQU CHM_BASE+40	       ;wParam=nChar                   lParam=nValue
CHM_SETCOMMENTBLOCKS        EQU CHM_BASE+41	       ;wParam=lpStart                 lParam=lpEnd
CHM_SETWORDGROUP            EQU CHM_BASE+42	       ;wParam=0                               lParam=nGroup (0-15)
CHM_GETWORDGROUP            EQU CHM_BASE+43	       ;wParam=0                               lParam=0
CHM_SETBMID                 EQU CHM_BASE+44	       ;wParam=nLines                  lParam=nBmID
CHM_GETBMID                 EQU CHM_BASE+45	       ;wParam=nLines                  lParam=0
CHM_ISCHARPOS               EQU CHM_BASE+46	       ;wParam=CP                              lParam=0, returns 1 if comment block, 2 if comment, 3 if string
CHM_HIDELINES               EQU CHM_BASE+47	       ;wParam=nLine                   lParam=nLines
CHM_SETDIVIDERLINE          equ CHM_BASE+48	       ;wParam=nLine, lParam=TRUE/FALSE
CHM_ISINBLOCK               equ CHM_BASE+49	       ;wParam=nLine, lParam=lpRABLOCKDEF
CHM_TRIMSPACE               equ CHM_BASE+50	       ;wParam=nLine, lParam=fLeft
CHM_SAVESEL                 equ CHM_BASE+51	       ;wParam=0, lParam=0
CHM_RESTORESEL              equ CHM_BASE+52	       ;wParam=0, lParam=0
CHM_GETCURSORWORD           equ CHM_BASE+53	       ;wParam=BuffSize, lParam=lpBuff
CHM_SETSEGMENTBLOCK         equ CHM_BASE+54        ;wParam=nLine, lParam=TRUE/FALSE
CHM_GETMODE                 equ CHM_BASE+55        ;wParam=0, lParam=0
CHM_SETMODE                 equ CHM_BASE+56        ;wParam=nMode, lParam=0
CHM_GETBLOCK                equ CHM_BASE+57        ;wParam=0, lParam=lpBLOCKRANGE
CHM_SETBLOCK                equ CHM_BASE+58        ;wParam=0, lParam=lpBLOCKRANGE
CHM_BLOCKINSERT             equ CHM_BASE+59        ;wParam=0, lParam=lpText
CHM_LOCKUNDOID              equ CHM_BASE+60        ;wParam=TRUE/FALSE, lParam=0

; More CodeHi messages--> STANDARD WINDOWS MESSAGES
; Uncommented constants are from masm32 package 
;--------------------
EM_EXLINEFROMCHAR           equ WM_USER + 54
;wParam=0
;lParam=cp
;
EM_EXSETSEL                 equ WM_USER + 55
;wParam=0
;lParam=lpCHARRANGE
;
EM_EXGETSEL                 equ WM_USER + 52
;wParam=0
;lParam=lpCHARRANGE
;
EM_FINDTEXTEX               equ WM_USER + 79
;wParam=Flags
;lParam=lpFINDTEXTEX
;
EM_GETTEXTRANGE             equ WM_USER + 75
;wParam=0
;lParam=lpTEXTRANGE
;
EM_FINDWORDBREAK            equ WM_USER + 76
;wParam=uFlags
;lParam=cp
;
EM_CANREDO                  equ WM_USER + 85
;wParam=0
;lParam=0
;
EM_REDO                     equ WM_USER + 84
;wParam=0
;lParam=0
;
EM_HIDESELECTION            equ WM_USER + 63
;wParam=TRUE/FALSE
;lParam=0
;
EM_GETSELTEXT               equ WM_USER + 62
;wParam=0
;lParam=lpBuff
;
EM_CANPASTE                 equ WM_USER + 50
;wParam=CF_TEXT
;lParam=0
;
EM_STREAMIN                 equ WM_USER + 73
;wParam=SF_TEXT
;lParam=lpStream
;
EM_STREAMOUT                equ WM_USER + 74
;wParam=SF_TEXT
;lParam=lpStream
;
;EM_CHARFROMPOS
;wParam=0
;lParam=lpPoint
;
;EM_POSFROMCHAR
;wParam=lpPoint
;lParam=cp
;
;EM_LINEFROMCHAR
;wParam=cp
;lParam=0
;
;EM_LINEINDEX
;wParam=line
;lParam=0
;
;EM_LINELENGTH
;wParam=cp
;lParam=0
;
;EM_GETLINE
;wParam=Line
;lParam=lpBuff
;
;EM_GETFIRSTVISIBLELINE
;wParam=0
;lParam=0
;
;EM_LINESCROLL
;wParam=cxScroll
;lParam=cyScroll
;
;EM_SCROLLCARET
;wParam=0
;lParam=0
;
;EM_SETSEL
;wParam=cpMin
;lParam=cpMax
;
;EM_GETSEL
;wParam=lpcpMin
;lParam=lpcpMax
;
;EM_GETMODIFY
;wParam=0
;lParam=0
;
;EM_SETMODIFY
;wParam=TRUE/FALSE
;lParam=0
;
;EM_REPLACESEL
;wParam=TRUE/FALSE
;lParam=lpText
;
;EM_GETLINECOUNT
;wParam=0
;lParam=0
;
;EM_GETRECT
;wParam=0
;lParam=lpRECT
;
;EM_CANUNDO
;wParam=0
;lParam=0
;
;EM_UNDO
;wParam=0
;lParam=0
;
;EM_EMPTYUNDOBUFFER
;wParam=0
;lParam=0
;
;WM_COPY
;wParam=0
;lParam=0
;
;WM_CUT
;wParam=0
;lParam=0
;
;WM_PASTE
;wParam=0
;lParam=0
;
;WM_CLEAR
;wParam=0
;lParam=0
;
;WM_SETTEXT
;wParam=0
;lParam=lpszText
;
;WM_GETTEXT
;wParam=cbBuff
;lParam=lpBuff
;
;WM_GETTEXTLENGTH
;wParam=0
;lParam=0

