;=======================================================================
_bs = 512   ; bytes per sector
_st = 18    ; sectors per track
_hd = 2     ; heads
_tr = 80    ; tracks
_rd = 224   ; root directory entries
_ft = 2     ; fats
_sf = 9     ; sectors per fat
_sc = 1     ; sectors per claster
;=======================================================================
include "fat12.inc"
;=======================================================================
    org 7C00h
    jmp start
    nop
;=====================================================
    db  "HE-HE OS";     ; 8                        BPB
    dw  _bs             ; b/s
    db  _sc             ; s/c  
    dw  _rs             ; rs
    db  _ft             ; fats
    dw  _rd             ; rde
    dw  _tr * _hd * _st ; as 
    db  0F0h            ; media
    dw  _sf             ; s/fat
    dw  _st             ; s/t
    dw  _hd             ; h
    dd  0               ; hs
    dd  0               ; --
    db  0               ; drv
    db  0               ; --
    db  29h             ; ebr
    dd  0               ; sn
    db  "NO NAME    ";  ; 11
    db  "FAT12   ";     ; 8
;=====================================================
start:
    mov   ax,cs
    mov   ds,ax
    mov   cx,count
    mov   si,hello
    mov   bx,7
    mov   ah,0Eh
@@:
    lodsb
    int   10h
    loop  @B
    xor   ah,ah
    int   16h
    int   19h

hello   db "Hi! This is disk-invalid!"
count = $ - hello  
    
;-----------------------------------------------------------------------
    rb 7E00h-2-$
    db 055h,0AAh ; signature at the end of the first sector
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   here you can continue coding - 
;   this will just increase amount of reserved sectors automatically

;-----------------------------------------------------------------------
    align _bs
    _rs = ($ - 7C00h) / _bs ; calculation of amount of reserved sectors
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   including files into the image and generating fat.
;   you should check for the first string - file name and extension
;   - it does not checked by macro, thus error can cause unreadable
;   directory entry

    fat12 \ 
        "A       TXT","a.txt",ff0,\
        "B       TXT","b.txt",ff1,\
        "KERNEL  BIN","kernel.bin",ff2
        
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    