;=======================================================================
format PE CONSOLE           
;=======================================================================
include 'win32a.inc'    ;*
include "combstr.inc"   ; some handy stuff 
;-----------------------------------------------------------------------
MAX_PARAMS = 2
MIN_PARAMS = 2
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
section '.code' code readable executable
;-----------------------------------------------------------------------
entry $
;-----------------------------------------------------------------------
    invoke GetCommandLine
    stdcall GetParameter,eax        ; skip exe name
    stdcall GetParameter,edx        ; get first parameter
    jnz @F                          ; optimized checking
    mov edx,err0
    jmp error                       ; empty commandline - help screen
@@:
    mov [iname],eax
    cmp byte [edx],0
    mov byte [edx],0
    je  cmderror                    ; no more parameters - error
    inc edx
    stdcall GetParameter,edx        ; get second parameter
    jz  cmderror                    ; no  second parameter - error
    mov [oname],eax
    cmp byte [edx],0
    mov byte [edx],0
    jne @F
    stdcall GetParameter,edx        ; get extra parameter
    jnz cmderror                    ; has some extra parameters - error
@@:    
;-----------------------------------------------------------------------
;   Opening filenames
;-----------------------------------------------------------------------
    invoke PathUnquoteSpaces,[iname]
    invoke PathUnquoteSpaces,[oname]
;-----------------------------------------------------------------------
    invoke CreateFile,[iname],GENERIC_READ,FILE_SHARE_READ,0,\
                              OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
    cmp eax,[ihand]
    mov edx,err2
    je  error
    mov [ihand],eax    
;-----------------------------------------------------------------------
    invoke CreateFile,[oname],GENERIC_WRITE,0,0,\
                              CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
    cmp eax,[ohand]
    mov edx,err3
    je  error
    mov [ohand],eax    
;-----------------------------------------------------------------------
CHAR_SIZE equ 1             ; 1 - for byte, 2 - for word, 4 - for dword
;-----------------------------------------------------------------------
;   Reading
;-----------------------------------------------------------------------
next:
    invoke ReadFile,[ihand],ibuff,CHAR_SIZE,cnt,0
    cmp [cnt],0
    je  done
;-----------------------------------------------------------------------
;   Processing
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    mov eax,[ibuff]
    mov [obuff],eax
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   Writing
;-----------------------------------------------------------------------
    invoke WriteFile,[ohand],obuff,CHAR_SIZE,cnt,0
    cmp [cnt],CHAR_SIZE
    je  next    
    mov edx,err3
    jmp error           ; error writing to file
;-----------------------------------------------------------------------
cmderror:               ; error in commandline
    mov edx,err1    
;-----------------------------------------------------------------------
error:                  ; in edx - pointer to error message
    push 0
    push cnt
    push edx
    invoke lstrlen,edx
    pop  edx
    push eax
    push edx
    invoke GetStdHandle,STD_ERROR_HANDLE
    invoke WriteFile,eax
    mov [cnt],1
;-----------------------------------------------------------------------
done:
    cmp [ihand],INVALID_HANDLE_VALUE
    je  @F
    invoke CloseHandle,[ihand]
@@:
    cmp [ohand],INVALID_HANDLE_VALUE
    je  @F
    invoke CloseHandle,[ohand]
@@:
    invoke ExitProcess,[cnt]
;-----------------------------------------------------------------------
    CSSupport
;-----------------------------------------------------------------------
include "cmdparse.inc" 
include "a2i.inc"
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
section '.data' data readable writeable
err1    db 13,10,"Error in the commandline"
err0    db 13,10,"Usage: <thistool> <input_file> <output_file>"
crlf    db 13,10,0
err2    db 13,10,"Error reading file",13,10,0
err3    db 13,10,"Error writing file",13,10,0
;-----------------------------------------------------------------------
        align 4
ihand   dd INVALID_HANDLE_VALUE
ohand   dd INVALID_HANDLE_VALUE
cnt     dd 0
iname   dd ?
oname   dd ?
ibuff   dd ?
obuff   dd ?
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
include "idata.inc"
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
